Show / Hide Table of Contents

# Class BaseAddressResolver

Base memory address resolver.

##### Inheritance

System.Object
BaseAddressResolver
ClientStateAddressResolver
FrameworkAddressResolver
ChatGuiAddressResolver
ContextMenuAddressResolver
FlyTextGuiAddressResolver
PartyFinderAddressResolver
ToastGuiAddressResolver
LibcFunctionAddressResolver
GameNetworkAddressResolver

##### Inherited Members

System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)
System.Object.ToString()

###### Namespace: Dalamud.Game

###### Assembly: Dalamud.dll

##### Syntax

    public abstract class BaseAddressResolver

### Properties

| Improve this Doc View Source

#### DebugScannedValues

Gets a list of memory addresses that were found, to list in /xldata.

##### Declaration

    public static Dictionary<string, List<(string ClassName, IntPtr Address)>> DebugScannedValues { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.Dictionary<System.String, System.Collections.Generic.List<System.ValueTuple<System.String, System.IntPtr>>> |

| Improve this Doc View Source

#### IsResolved

Gets or sets a value indicating whether the resolver has successfully run Setup32Bit(SigScanner) or Setup64Bit(SigScanner).

##### Declaration

    protected bool IsResolved { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

### Methods

| Improve this Doc View Source

#### GetVirtualFunction<T>(IntPtr, Int32, Int32)

Fetch vfunc N from a pointer to the vtable and return a delegate function pointer.

##### Declaration

    public T GetVirtualFunction<T>(IntPtr address, int vtableOffset, int count)
        where T : class

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | address | The address of the virtual table.
System.Int32 | vtableOffset | The offset from address to the vtable pointer.
System.Int32 | count | The vfunc index.

##### Returns

Type | Description
--- | ---
T | A delegate function pointer that can be invoked.

##### Type Parameters

Name | Description
--- | ---
T | The delegate to marshal the function pointer to.

| Improve this Doc View Source

#### Setup()

Setup the resolver, calling the appopriate method based on the process architecture.

##### Declaration

    public void Setup()

| Improve this Doc View Source

#### Setup(SigScanner)

Setup the resolver, calling the appopriate method based on the process architecture.

##### Declaration

    public void Setup(SigScanner scanner)

##### Parameters

Type | Name | Description
--- | --- | ---
SigScanner | scanner | The SigScanner instance.

| Improve this Doc View Source

#### Setup32Bit(SigScanner)

Setup the resolver by finding any necessary memory addresses.

##### Declaration

    protected virtual void Setup32Bit(SigScanner scanner)

##### Parameters

Type | Name | Description
--- | --- | ---
SigScanner | scanner | The SigScanner instance.

| Improve this Doc View Source

#### Setup64Bit(SigScanner)

Setup the resolver by finding any necessary memory addresses.

##### Declaration

    protected virtual void Setup64Bit(SigScanner scanner)

##### Parameters

Type | Name | Description
--- | --- | ---
SigScanner | scanner | The SigScanner instance.

| Improve this Doc View Source

#### SetupInternal(SigScanner)

Setup the resolver by finding any necessary memory addresses.

##### Declaration

    protected virtual void SetupInternal(SigScanner scanner)

##### Parameters

Type | Name | Description
--- | --- | ---
SigScanner | scanner | The SigScanner instance.